// define the stepper driver pins
#define IN1  5
#define IN2  6
#define IN3  7
#define IN4  8

// define how many cycles to a full rotation
#define CYCLES_PER_ROTATION 512
//9*128.26    512 or 129

// servo
#include <Servo.h>
Servo myservo;  // create servo object to control a servo


void setup()
{
  Serial.begin(115200);
  pinMode(IN1, OUTPUT);
  pinMode(IN2, OUTPUT);
  pinMode(IN3, OUTPUT);
  pinMode(IN4, OUTPUT);
  
  // servo
//myservo.attach(11);  // attaches the servo on pin 9 to the servo object
//myservo.write(180);
//delay(1000);
//myservo.detach();

}

void loop()
{
//turns(4800);
//delay(1000);

  //String Try="-1";
  //  Serial.println(Try);
  //  if(Try.charAt(0)=='-'){
  //  Try.setCharAt(0,'0');}
  //  int tryNum = Try.toInt();
  //Serial.println(-tryNum);
  //

  while (Serial.available() == 0);

  String xYZ = Serial.readStringUntil('\r');


  if (xYZ == "Ready?") {
    Serial.println("Ready");
  }
  else if (xYZ != "Ready?") {


    if (xYZ.charAt(0) == 'm') { // ANTI-clockwise (if turns begins with "m")
      xYZ.setCharAt(0, '0');
      int steps = xYZ.toInt();
      //Serial.println(2*steps);
      turns(-steps); // passes xYZ as number of steps to the stepper
    }

    else if (xYZ.charAt(0) == 'p') { // CLOCKwise (if turns does begins with "p")
      xYZ.setCharAt(0, '0');
      int steps = xYZ.toInt();
      turns(steps); // passes xYZ as number of steps to the stepper
    }
  
  else if (xYZ.charAt(0) == 's') { // servo instructions begin with 's')
      xYZ.setCharAt(0, '0');
      int steps = xYZ.toInt();
      myservo.attach(11);  // attaches the servo on pin 9 to the servo object
      myservo.write(steps); // passes xYZ to the servo
      delay(1000);
      myservo.detach();
      //Serial.println("servo");
    }
  
  }


  // make the stepper do 1.5 rotations CW
  //turns(1);
  //delay(1000);
  // make the stepper do 1.5 rotations CCW
  //turns(-1);
  //delay(1000);

}

void turns(float rotations)
{
  // if the rotation count is -ve then it is CCW
  //  Serial.println();
  //  Serial.print("Turning : ");
  //  Serial.print(rotations);
  //  Serial.println(" rotations");
  bool clockwise = rotations > 0;
  //  Serial.print("Clockwise = ");
  //  Serial.println(clockwise);
  
  // calculate how many cycles the stepper will have to make

  //int cycles = rotations * CYCLES_PER_ROTATION;
  int cycles = rotations;
  // force the cycle count to be positive
  cycles = abs(cycles);
  //  Serial.print("That is ");
  //  Serial.print(cycles);
  //  Serial.print(" Cycles ");
  // only move if the user specifed an actual movement
  if (rotations != 0)
  {
    if (clockwise)
    {
      //Serial.println("Clockwise");
      // for each cycle
      for (int x = 0; x < cycles; x++)
      {
        // for each phase
        for (int y = 0; y < 8; y++)
        {
          // go to phase y
          phaseSelect(y);
          // pause so the stepper has time to react
          delay(1);
        }
      }
    } else {
      //Serial.println("Counter Clockwise");
      // for each cycle
      for (int x = 0; x < cycles; x++)
      {
        // for each phase (backwards for CCW rotation)
        for (int y = 7; y >= 0; y--)
        {
          // go to phase y
          phaseSelect(y);
          // pause so the stepper has time to react
          delay(1);
        }
      }
    }
  }
  // go to the default state (all poles off) when finished
  phaseSelect(8);


  //Serial.println("Done");


}

void phaseSelect(int phase)
{
  switch (phase) {
    case 0:
      digitalWrite(IN1, LOW);
      digitalWrite(IN2, LOW);
      digitalWrite(IN3, LOW);
      digitalWrite(IN4, HIGH);
      break;
    case 1:
      digitalWrite(IN1, LOW);
      digitalWrite(IN2, LOW);
      digitalWrite(IN3, HIGH);
      digitalWrite(IN4, HIGH);
      break;
    case 2:
      digitalWrite(IN1, LOW);
      digitalWrite(IN2, LOW);
      digitalWrite(IN3, HIGH);
      digitalWrite(IN4, LOW);
      break;
    case 3:
      digitalWrite(IN1, LOW);
      digitalWrite(IN2, HIGH);
      digitalWrite(IN3, HIGH);
      digitalWrite(IN4, LOW);
      break;
    case 4:
      digitalWrite(IN1, LOW);
      digitalWrite(IN2, HIGH);
      digitalWrite(IN3, LOW);
      digitalWrite(IN4, LOW);
      break;
    case 5:
      digitalWrite(IN1, HIGH);
      digitalWrite(IN2, HIGH);
      digitalWrite(IN3, LOW);
      digitalWrite(IN4, LOW);
      break;
    case 6:
      digitalWrite(IN1, HIGH);
      digitalWrite(IN2, LOW);
      digitalWrite(IN3, LOW);
      digitalWrite(IN4, LOW);
      break;
    case 7:
      digitalWrite(IN1, HIGH);
      digitalWrite(IN2, LOW);
      digitalWrite(IN3, LOW);
      digitalWrite(IN4, HIGH);
      break;
    default:
      digitalWrite(IN1, LOW);
      digitalWrite(IN2, LOW);
      digitalWrite(IN3, LOW);
      digitalWrite(IN4, LOW);
      break;
  }
}
